#!/usr/bin/env python2

__author__ = 'Moorthy Rajendran <rmoorthy@collab.net>'
__copyright__ = "Copyright (c) 2014 CollabNet, Inc. All rights reserved."

import os
import app.clireports.constants
import app.db

class DBase:

    def __init__(self):

        self._dbCon = None
        try:
           self._dbCon = app.db.getConnection()
        except Exception, e:
           raise e

        return

    def softDeleteReportTypeMetaData(self, reportType):

        sql = "update report_type_meta_data set is_deleted='%s' where type='%s'"

        isDeleted = 't';
        if (self._getDbType() == 'oracle'):
           isDeleted = '1';

        try:
           status = self._executeSql(sql, (isDeleted, reportType))
           return status
        except Exception, e:
           raise e

    def modifyReportTypeMetaData(self, reportType, category, formConfigData, chartConfigData, timeToLive=24):
        
        sql = "update report_type_meta_data set form_config='%s',chart_config='%s',time_to_live='%s',is_deleted='%s' where type='%s' and category='%s'"

        isDeleted = 'f';
        if (self._getDbType() == 'oracle'):
           isDeleted = '0';

        try:
           status = self._executeSql(sql, (formConfigData, chartConfigData, timeToLive, isDeleted, reportType, category))
           return status
        except Exception, e:
           raise e

    def addReportTypeMetaData(self, reportType, category, formConfigData, chartConfigData, timeToLive=24):

        newSurgId = self.generateSurrogateIdFromSequence('report_type_meta_key_seq')
        sql = "insert into report_type_meta_data (surrogate_id, type, category, form_config, chart_config, time_to_live, is_deleted) values ('%s','%s','%s','%s','%s','%s','%s')"
        isDeleted = 'f';
        if (self._getDbType() == 'oracle'):
           isDeleted = '0';

        try:
           status = self._executeSql(sql, (newSurgId, reportType, category, formConfigData, chartConfigData, timeToLive, isDeleted))
           return status
        except Exception, e:
           raise e

    def ifReportTypeMetaDataExist(self, reportType):

        sql = "select surrogate_id from report_type_meta_data where type='%s'"
        try:
           if len(self._fetchData(sql, (reportType))) > 0:
              return True
           else:
              return False
        except:
           return False

    def ifReportTypeCategoryMetaDataExist(self, reportType, category):

        sql = "select surrogate_id from report_type_meta_data where type='%s' and category='%s'"
        try:
           if len(self._fetchData(sql, (reportType, category))) > 0:
              return True
           else:
              return False
        except:
           return False

    def modifyReportType(self, reportType, reportTitle, description, imageUrl, almRequired, datamartRequired, eventsRequired, devOpsRequired, collabRequired, scmRequired):

        if (self._getDbType() == 'oracle'):
            almRequired = '1' if (almRequired.lower() == 'true') else '0'  
            datamartRequired = '1' if (datamartRequired.lower() == 'true') else '0'
            eventsRequired = '1' if (eventsRequired.lower() == 'true') else '0'
            devOpsRequired = '1' if (devOpsRequired.lower() == 'true') else '0'
            collabRequired = '1' if (collabRequired.lower() == 'true') else '0'
            scmRequired = '1' if (scmRequired.lower() == 'true') else '0'
        else:
            almRequired = 't' if (almRequired.lower() == 'true') else 'f'
            datamartRequired = 't' if (datamartRequired.lower() == 'true') else 'f'
            eventsRequired = 't' if (eventsRequired.lower() == 'true') else 'f'
            devOpsRequired = 't' if (devOpsRequired.lower() == 'true') else 'f'
            collabRequired = 't' if (collabRequired.lower() == 'true') else 'f'
            scmRequired = 't' if (scmRequired.lower() == 'true') else 'f'

        try:
           sql = "update report_type set title='%s',description='%s',image_url='%s',alm_required='%s',datamart_required='%s',events_required='%s',devops_required='%s',collab_required='%s',scm_required='%s' where id='%s'"
           status = self._executeSql(sql, (reportTitle, description, imageUrl, almRequired, datamartRequired, eventsRequired, devOpsRequired, collabRequired, scmRequired, reportType))
           return status
        except Exception, e:
           raise e

    def addReportType(self, reportType, reportTitle, description, imageUrl, almRequired, datamartRequired, eventsRequired, devOpsRequired, collabRequired, scmRequired):

        if (self._getDbType() == 'oracle'):
            almRequired = '1' if (almRequired.lower() == 'true') else '0'
            datamartRequired = '1' if (datamartRequired.lower() == 'true') else '0'
            eventsRequired = '1' if (eventsRequired.lower() == 'true') else '0'
            devOpsRequired = '1' if (devOpsRequired.lower() == 'true') else '0'
            collabRequired = '1' if (collabRequired.lower() == 'true') else '0'
            scmRequired = '1' if (scmRequired.lower() == 'true') else '0'
        else:
            almRequired = 't' if (almRequired.lower() == 'true') else 'f'
            datamartRequired = 't' if (datamartRequired.lower() == 'true') else 'f'
            eventsRequired = 't' if (eventsRequired.lower() == 'true') else 'f'
            devOpsRequired = 't' if (devOpsRequired.lower() == 'true') else 'f'
            collabRequired = 't' if (collabRequired.lower() == 'true') else 'f'
            scmRequired = 't' if (scmRequired.lower() == 'true') else 'f'

        try:
           newSurgId = self.generateSurrogateIdFromSequence('report_type_key_seq')
           sql = "insert into report_type (surrogate_id, id, title, description, image_url, alm_required, datamart_required, events_required, devops_required, collab_required, scm_required) values ('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')"
           status = self._executeSql(sql, (newSurgId, reportType, reportTitle, description, imageUrl, almRequired, datamartRequired, eventsRequired, devOpsRequired, collabRequired, scmRequired))
           return status
        except Exception, e:
           raise e

    def ifReportTypeExist(self, reportType):

        sql = "select surrogate_id from report_type where id='%s'"
        try:
           if len(self._fetchData(sql, (reportType))) > 0:
              return True
           else:
              return False
        except:
           return False

    def addReportCategory(self, categoryType, categoryTitle, description):

        try:
           newSurgId = self.generateSurrogateIdFromSequence('report_category_key_seq')
           sql = "insert into report_category (surrogate_id, id, title, description) values ('%s','%s','%s','%s')"
           status = self._executeSql(sql, (newSurgId, categoryType, categoryTitle, description))
           return status
        except Exception, e:
           raise e

    def ifReportCategoryExist(self, categoryType):

        sql = "select surrogate_id from report_category where id='%s'"
        try:
           if len(self._fetchData(sql, (categoryType))) > 0:
              return True
           else:
              return False
        except:
           return False

    def generateSurrogateIdFromSequence(self, seqName='report_type_key_seq'):

        if (self._getDbType() == 'oracle'):
           sql = "select %s.nextval from dual"%seqName
        else:
           sql = "select nextval('%s')"%seqName

        try:
           nextId = self._fetchData(sql)[0][0]
           return nextId
        except Exception, e:
           raise e

    def _getDbType(self):
        return app.db.gDbType

    def _prepareSql(self, sql, bindVals=None):
        if bindVals != None:
           sql = sql%(bindVals)

        return sql

    def _fetchData(self, sql, bindVals=None):

        results = []
        try:
            cur = self._dbCon.cursor()
            runsql = self._prepareSql(sql, bindVals)
            if (self._getDbType() == 'oracle'):
               cur.execute(u"%s" %runsql)
            else:
               cur.execute(runsql)
            results = cur.fetchall()
            return results
        except Exception, e:
            raise e


    def _executeSql(self, sql, bindVals=None):

        try:
            cur = self._dbCon.cursor()
            runsql = self._prepareSql(sql, bindVals)
            if (self._getDbType() == 'oracle'):
               cur.execute(u"%s" %runsql)
            else:
               cur.execute(runsql)
            self._dbCon.commit()
            return cur.rowcount
        except Exception, e:
            raise e


