__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript
import service.util
import service.constants

class ConfigScript(BaseConfigScript):
    def configSnippet(self):
        domain=self.cfg['APPSERVER_DOMAIN']

        rules = ''
        additionalRedirectRule = ''
        catchAllRedirectRule = ''
        scheme = self.cfg['HTTP_SCHEME']
        if scheme == 'https':
            rules = """
    RewriteRule /server-status - [R=permanent,L]

    RewriteCond %s ^%s
    RewriteRule /(.*) %s://%s/$1 [R=permanent,L]

    RewriteCond %s ^(.*)\.%s
    RewriteRule /(.*) %s://%s [R=permanent,L]
""" % ('%{HTTP_HOST}', self.cfg['CEE_DOMAIN'], scheme, domain,
       '%{HTTP_HOST}', self.cfg['CEE_DOMAIN'], scheme, '%{HTTP_HOST}%{REQUEST_URI}')

            if self.cfg['NODE_HOSTNAME'] != self.cfg['APPSERVER_DOMAIN']:
                additionalRedirectRule = """
    RewriteCond %s ^%s
    RewriteRule /(.*) %s://%s/$1 [R=permanent,L]
""" %('%{HTTP_HOST}', self.cfg['NODE_HOSTNAME'], scheme, domain)

            catchAllRedirectRule = """
    RewriteRule /(.*) %s://%s/$1 [R=permanent,L]
""" %(scheme, domain)

        confStr = """
<VirtualHost *:80>
    RewriteEngine on
    RewriteOptions inherit

    # This is needed for Gerrit compatibility, but does not hurt other services.
    AllowEncodedSlashes On

    # Set request header for url protocol
    RequestHeader set X_FORWARDED_PROTO 'http'

    %s
    %s
    %s
</VirtualHost>
""" % (rules, additionalRedirectRule, catchAllRedirectRule)
        return confStr

