__copyright__ = "Copyright (c) 2010 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript
import service.util
import service.constants

class ConfigScript(BaseConfigScript):
    def configSnippet(self):

        secureRedirects = self.cfg.has_key("SECURE_REDIRECTS") and self.cfg["SECURE_REDIRECTS"]=="true"

        if secureRedirects:

           confStr= """

ErrorDocument 400 /400_HTTP_ERROR_PAGE.html

#SECURITY
#Checks if the request header HOST has been tamperred
RewriteCond %{HTTP_HOST} !={__APPSERVER_DOMAIN__} [nc]
RewriteCond %{HTTP_HOST} !=www.{__APPSERVER_DOMAIN__} [nc]
RewriteCond %{HTTP_HOST} !^localhost [nc]
RewriteCond %{HTTP_HOST} !^127\.0\.0\.1 [nc]
RewriteCond %{HTTP_HOST} !={__SITE_HOST__} [nc]
RewriteCond %{HTTP_HOST} !={__NODE_HOSTNAME__} [nc]
"""
           hosts = [hostName.split( "_")[1] for (hostName, applications) in
           self.cfg.items() if hostName.rfind("HOST_") == 0]

           for hostname in hosts:
               if 'localhost' in hosts: #This check is for escaping security checks for vmware installation.
                  return ""

           
           # Now add the rewrite condition for "ALLOWED_HOSTS" if it exists

           if (self.cfg.has_key("ALLOWED_HOSTS") and self.cfg['ALLOWED_HOSTS'] != 'none'):
              allowedHosts =  self.cfg['ALLOWED_HOSTS'].split(" ")
              for allowedHost in allowedHosts:
                  confStr += "RewriteCond %{HTTP_HOST} !=" + "%s [nc]\n" %(allowedHost)
          
           confStr += """RewriteCond %{REQUEST_URI} !=/400_HTTP_ERROR_PAGE.html
RewriteRule (.*) {__HTTP_SCHEME__}://{__APPSERVER_DOMAIN__} [R=400,L]

"""
           return confStr;

        else:
		return ""
