__copyright__ = "Copyright (c) 2010 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import os
import shutil

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Setup Apache Error pages"

    def createRuntime(self):

        secureRedirects = self.cfg.has_key("SECURE_REDIRECTS") and self.cfg["SECURE_REDIRECTS"]=="true"

        if secureRedirects:

           documentRootFolder = self.cfg['HTTPD_DOCUMENT_ROOT']

           #Get the 400 error page file from dist.
           httpdErrorPageFile = os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'apache', 'code-templates', '400_HTTP_ERROR_PAGE.html')

           #Copy 400 error page to httpd document root folder
           shutil.copy(httpdErrorPageFile, documentRootFolder)

