__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import service.util
import service.constants
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create CodeSearch properties"

    def createRuntime(self):
        propFile = os.path.join(self.cfg['RUNTIME_DIR'], 'conf', 'codesearch.properties')

        # Create the codesearch.properties file only if codesearch is to run locally
        batch = app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'bdcs', 'conf-snippets', 'codesearch-properties.d'))
            
        if not (self.cfg.has_key("BDCS_TOMCAT_MX_IN_MB") and self.cfg['BDCS_TOMCAT_MX_IN_MB'].isdigit()):
            batch.removeFile('01-codesearch-tomcat-heapsize.properties')

        batch.evaluateIntoFile(propFile)

        # Check and create codesearch log directory
        bdcsLogDir = self.cfg['BDCS_LOG_DIR'];
        if not(os.path.isdir(bdcsLogDir)):
           os.mkdir(bdcsLogDir)

        etcDir = os.path.join(self.cfg['SITE_DIR'], 'etc')
        if not(os.path.isdir(etcDir)):
           os.mkdir(etcDir)

        # Check and create temporary directory
        tempDir = self.cfg['TEMPORARY_DIR'];
        if not(os.path.isdir(tempDir)):
           os.mkdir(tempDir)
