import os
import app.servicecontrol
import app.defaults

class ServiceController(app.servicecontrol.ServiceController):
    def getPidFile(self):
        return "/var/run/bds-codesight-tomcat.pid"

    def __runInit(self, verb):
        config = app.util.getRuntimeConfiguration()

        logFile = os.path.join(config['BDCS_LOG_DIR'], 'service.log')
        initScript = os.path.join(config['RUNTIME_SCRIPTS'], 'codesearch.sh')

        return os.system("%s %s < /dev/null >> %s 2>&1 &" % (initScript, verb, logFile)) == 0
        
    def startDaemonAsync(self):
        return self.__runInit("start")
        
    def stopDaemonAsync(self):
        return self.__runInit("stop")