#!/bin/bash

# Source the tokens

eval "`$RUNTIME_DIR/scripts/options-to-shell-variables.py`"

#Start Function
start() {
	pgsql_status; ret=$?
	if [ $ret -eq 0 ]; then
		echo -en "Starting Codesearch Postgresql .. "
		$BDCS_PGSQL_SERVICE_CMD start 2> /dev/null
		echo "Done"
	fi
	
	tomcat_status; ret=$?
	if [ $ret -eq 0 ]; then
		echo -en "Starting Codesearch Tomcat .. "
		$BDCS_TOMCAT_SERVICE_CMD start 2> /dev/null
		echo "Done"
	fi
}

#Stop Function
stop() {
	tomcat_status; ret=$?
	if [ $ret -eq 1 ]; then
		echo -en "Stopping Codesearch Tomcat .. "
		$BDCS_TOMCAT_SERVICE_CMD stop 2> /dev/null
		echo "Done"
	fi
	
	pgsql_status; ret=$?
	if [ $ret -eq 1 ]; then
		echo -en "Stopping Codesearch Postgresql .. "
		$BDCS_PGSQL_SERVICE_CMD stop 2> /dev/null
		echo "Done"
	fi
}

#Fetch Codesearch Tomcat status
tomcat_status() {
    ret=`$BDCS_TOMCAT_SERVICE_CMD status 2> /dev/null | grep "is running" | wc -l`

    if [ $ret -ge 1 ]; then
       return 1
    else
       return 0
    fi
}

#Fetch Codesearch Postgresql status
pgsql_status() {
    ret=`$BDCS_PGSQL_SERVICE_CMD status 2> /dev/null | grep "is running" | wc -l`

    if [ $ret -ge 1 ]; then
       return 1
    else
       return 0
    fi
}

#Codesearch Installed status
install_status() {
    if [ ! -x $BDCS_TOMCAT_SERVICE_CMD ]; then
         echo "ERROR: Codesearch is not installed."
         exit 1
    fi
}

install_status

case "$1" in
start)
	echo -en "Starting Codesearch .. "
        start
	echo "Done"
        ;;
stop)
	echo -en "Stopping Codesearch .. "
        stop
	echo "Done"
        ;;
status)
	echo -en "Codesearch Tomcat .. "
        tomcat_status; ret=$?
        if [ $ret -eq 1 ]; then
           echo "running"
        else
           echo "not running!!"
        fi
	echo -en "Codesearch Postgresql .. "
        pgsql_status; ret=$?
        if [ $ret -eq 1 ]; then
           echo "running"
        else
           echo "not running!!"
        fi
        ;;
*)

	echo "codesearch.sh <start|stop|status>"
	;;
esac

