#!/bin/bash
# SCRIPT:  repositorysql.sh
# PURPOSE: Get final repo sql from repo path
usage() {
cat << END_OF_FILE

Usage: `basename $0` --file <<input_file>>


Where <<input_file>> is the filename containing list of repository paths
   
END_OF_FILE
}

run() {
while true
do
        echo -n "This script generates sql to fetch list of repository ids given list of repository paths. Each repository path should be followed by new line.Do you want to proceed (y or n) :"
        read CONFIRM
        case $CONFIRM in
        y|Y|YES|yes|Yes) break ;;
        n|N|no|NO|No)
        echo Aborting - you entered $CONFIRM
        exit
        ;;
        *) echo Please enter only y or n
        esac
done
echo ""
count=0
totalcount=`wc -l $FILENAME | cut -d' ' -f1`
sql="select s.id from scm_repository s, folder f where s.repository_path in ('"
cat $FILENAME | while read LINE
do
       let count++
       
	       if [ $totalcount == 1 ]; then 
	       		reposql=$sql$LINE"') and s.id=f.id  and f.is_deleted='f';"
               		echo $reposql
       	       elif [ $count == 1 ]; then
               		reposql=$sql$LINE"',"
       	       else 
	       		reposql=$reposql"'"$LINE
               		if [ $count == $totalcount ]; then
                   		reposql=$reposql"') and s.id=f.id  and f.is_deleted='f';"
		    		echo $reposql
               		else
                    		reposql=$reposql"',"
              		fi
		fi
          
done
}


	
RETURNCODE=0
while [ $RETURNCODE -eq 0 ]; do
        case $1 in
        --help|-h)
                usage
                exit
                ;;
        --file*)
                FILENAME=`echo $1 | cut -d= -f2`;
                run
                exit
                ;;

	*)
        esac
	shift
        RETURNCODE=$?
done



