﻿__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

import re
from app.scripts import BaseConfigScript
import service.util
import service.constants
import app.options
class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        confStr = ""
        bdcsHost = service.util.getApplicationHost(service.constants.APPLICATION_CODESEARCH)
        if (bdcsHost != None):
            appName = service.constants.APPLICATION_CODESEARCH

            if (service.util.isApplicationEnabled(appName, bdcsHost)):
                if (self.cfg.isObfuscationEnabled()):
                    bdcsAdminPassword = app.options.Obfuscator.createFromRuntimeOptions(self.cfg) \
                         .obfuscate(self.cfg['BDCS_ADMIN_PASSWORD'])
                else:
                    bdcsAdminPassword = self.cfg['BDCS_ADMIN_PASSWORD']

                bdcsUrl = "%s://%s:%s"%(self.cfg['BDCS_TOMCAT_PROTOCOL'],
                                 self.cfg['ctfcore-app/dependency/bdcs/http/host'], self.cfg['ctfcore-app/dependency/bdcs/http/port'])


                confStr += """
#CodeSight URL 
codeSight.url=%s

#CodeSight SDK Search Limit
codeSight.searchResultsLimit=%s

#CodeSight Admin Username
codeSight.adminUsername=%s

#CodeSight Admin Password 
codeSight.adminPassword=%s
""" % (bdcsUrl,
       self.cfg['BDCS_SDK_SEARCH_LIMIT_MAX'],
       self.cfg['BDCS_ADMIN_USERNAME'],
       bdcsAdminPassword)
       
        return confStr
