__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseBootstrapScript
import app.util
import os

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Create Data folders"

    def __wipe(self, folder):
        if os.path.exists(folder):
            app.util.runSystem("rm -rf %s" % folder, self.log)
        os.makedirs(folder)
        
    def bootstrap(self):
        dataDir = self.cfg['DATA_DIR']
        if os.path.islink(dataDir):
            dataDir = os.readlink(dataDir)
        if not os.path.exists(dataDir):
            os.makedirs(dataDir)
            
        self.__wipe(self.cfg['FILESTORAGE_LOCATION'])
        self.__wipe(self.cfg['DELETED_FILES_LOCATION'])
        self.__wipe(self.cfg['DATA_ETC_LOCATION'])
        self.__wipe(os.path.join(self.cfg['DATA_DIR'], 'cracklib'))
        self.__wipe(os.path.join(self.cfg['DATA_DIR'], 'events'))
        self.__wipe(os.path.join(self.cfg['DATA_DIR'], 'overrides'))
        self.__wipe(os.path.join(self.cfg['DATA_DIR'], 'publish'))
        self.__wipe(os.path.join(self.cfg['DATA_DIR'], 'templates'))