from app.scripts import BaseBootstrapScript
import app.util
import os

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Create Branding overrides folder"

    def bootstrap(self):
        brandingOverridesDir = "%s/overrides" %(self.cfg['DATA_DIR'])
        if not os.path.exists(brandingOverridesDir):
            os.makedirs(brandingOverridesDir)

        os.chmod(brandingOverridesDir, 0755)
        
        apacheUser = self.cfg['HTTPD_USER']
        apacheGroup = self.cfg['HTTPD_GROUP']

        app.util.runSystem("chown %s:%s %s" % (apacheUser, apacheGroup, brandingOverridesDir),self.log)
