__copyright__ = "Copyright (c) 1999-2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Copy Teamforge EAR and WARs to JBoss deployment folder"

    def createRuntime(self):
        jbossDeployDir = self.cfg['JBOSS_SERVER_DEPLOY_DIR']
        jbossDeployEar = os.path.join(self.cfg['DEPLOY_FILES_DIR'], 'teamforge.ear')
        
        # teamforge.ear
        cmdStr = "unzip -qo %s -d %s/teamforge.ear" % (jbossDeployEar, jbossDeployDir)
        app.util.runSystem(cmdStr, self.log)
        app.util.runSystem("touch %s" % os.path.join(self.cfg['JBOSS_SERVER_DEPLOY_DIR'], 'teamforge.ear.dodeploy'), self.log)
        if self.cfg.has_key('TEST_SUPPORT_ENABLED') and self.cfg['TEST_SUPPORT_ENABLED'] == 'true':
            jbossDeployTestEar = os.path.join(self.cfg['DEPLOY_FILES_DIR'], 'teamforge.test.ear')
            cmdStr = "unzip -qo %s -d %s/teamforge.ear" % (jbossDeployTestEar, jbossDeployDir)
            app.util.runSystem(cmdStr, self.log)
        
        # integration.war
        jbossDeployIntegrationWar = os.path.join(self.cfg['DEPLOY_FILES_DIR'], 'integration.war')
        cmdStr = "cp -rf %s %s/" % (jbossDeployIntegrationWar, jbossDeployDir)
        app.util.runSystem(cmdStr, self.log)

        # Reapply ownership
        app.util.runSystem("chown -R %s:%s %s" % (self.cfg['APP_USER'], self.cfg['APP_GROUP'], jbossDeployDir), self.log)

