__copyright__ = "Copyright (c) 2014 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os
import commands
import sys

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Deploy HighCharts Exporter Web to JBoss"

    def createRuntime(self):
        highChartWarApp = 'highcharts-export-web.war'
        deployLocation  = os.path.join(self.cfg['JBOSS_SERVER_DEPLOY_DIR'],
                                     highChartWarApp)
        warToDeploy     = os.path.join(self.cfg['DEPLOY_FILES_DIR'],
                                     highChartWarApp)

        # Create highcharts-export-web.war folder
        app.util.runSystem("mkdir -p %s > /dev/null 2>&1" % deployLocation, self.log)

        # Unjar highcharts-export-web.war in JBoss Deployment folder
        cmdStr = "cd %s && jar -xf %s > /dev/null"%(deployLocation, warToDeploy)
        (retVal, outputVal) = commands.getstatusoutput(cmdStr)
        if (retVal != 0):
           self.logMesg("error", "Unable to deploy HighCharts Exporter application to JBoss!!")
           self.logMesg("error", "Reason: %s"%(outputVal))
           sys.exit(1)

        # Create dodeploy marker file for jboss server to start highcharts-export-web application
        app.util.runSystem("touch %s" % os.path.join(self.cfg['JBOSS_SERVER_DEPLOY_DIR'], 
                    '%s.dodeploy'%highChartWarApp), self.log)

        # Override app-convert.properties file
        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'ctfcore-app', 'conf-snippets', 'highcharts-export-app-convert.properties.d')) \
            .evaluateIntoFile(os.path.join(deployLocation, "WEB-INF", "spring", "app-convert.properties"))
