
from app.scripts import BaseCreateRuntimeScript
import app.util
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create SVN branding repository base path"

    def createRuntime(self):

        brandRepoBasePath = self.cfg["SUBVERSION_BRANDING_REPOSITORY_BASE"]
        self.checkAndCreateBrandingRepoBasePath(brandRepoBasePath)

    def checkAndCreateBrandingRepoBasePath(self, brandRepoBasePath):

        if os.path.isdir(brandRepoBasePath):
            return

        scmUser = self.cfg['HTTPD_USER']
        scmGroup = self.cfg['HTTPD_GROUP']
        cmd = "mkdir -p %s" % brandRepoBasePath
        chownCmd = "chown %s:%s %s" % (scmUser, scmGroup, brandRepoBasePath)
                
        app.util.runSystem(cmd, self.log)
        app.util.runSystem(chownCmd, self.log)


