__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseBootstrapScript
import app.util
import os
import app.pgdbadmin 
import app.schemerator

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Bootstrap App database"

    def bootstrap(self):
        dbHost = self.cfg['ctfcore-database-admin-postgres/dependency/ctfcore-database/jdbc/host']
        dbName = self.cfg['DATABASE_NAME']
        dbPort = self.cfg['ctfcore-database-admin-postgres/dependency/ctfcore-database/jdbc/port']
        dbSSL  = self.cfg['DATABASE_SSL']

        dbUrl = "jdbc:postgresql://%s:%s/%s" % (dbHost, dbPort, dbName)
        if dbSSL == "on":
            dbUrl += '?ssl=true&sslfactory=org.postgresql.ssl.NonValidatingFactory&'

        try:
            app.schemerator.Schemerator(
                self.cfg['BOOTSTRAP_JAR'],
                dbUrl,
                self.cfg.get('DATABASE_USERNAME'),
                self.cfg.get('DATABASE_PASSWORD')).run(self.log)
                
        except app.schemerator.SchemeratorSchemaExistsException:
            raise Exception("Database schema already exists. To recreate the schema, "+
                            "bootstrap the service 'ctfcore-database-postgres' first")
            
        db = app.pgdbadmin.PGCTFDBManager(
            dbName,
            self.cfg.get('DATABASE_USERNAME'),
            self.cfg.get('DATABASE_PASSWORD'),
            self.cfg.get('DATABASE_READ_ONLY_USER'),
            self.cfg.get('DATABASE_READ_ONLY_PASSWORD'),
            self.log,
            dbPort,
            dbHost,
            self.cfg.get('PGPASSFILE'))
        db.grantReadOnlyPermissionsForAllTablesInSchema()
        db.revokePermissionForTables(['sfuser', 'password_history'])