from app.scripts import BaseMigrationScript

import os
import app.util

class MigrationScript(BaseMigrationScript):
    
    scriptDescription = "Migrate CTF Reports Database to latest schema"

    def migrate(self):
        databaseType = self.cfg['DATABASE_TYPE']
              
        jdbcUrl = "jdbc:oracle:thin:@%s:%s:%s" % \
            (self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-database/jdbc/host'], self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-database/jdbc/port'], self.cfg['DATABASE_NAME'])
        
        reportsJdbcUrl = "jdbc:oracle:thin:@%s:%s:%s" % \
            (self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-datamart/jdbc/host'], self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-datamart/jdbc/port'], self.cfg['REPORTS_DATABASE_NAME'])
        
        args = [
            jdbcUrl,
            self.cfg['DATABASE_USERNAME'],
            "".join(["'", self.cfg['DATABASE_PASSWORD'], "'"]),
            "''",
            "true",
            reportsJdbcUrl,
            self.cfg['REPORTS_DATABASE_USERNAME'],
            "".join(["'", self.cfg['REPORTS_DATABASE_PASSWORD'], "'"]),
            "''"
            ]
            
        command = "%s/bin/java -Djava.security.egd=file:///dev/urandom -Xms128m -Xmx1024m -Xss8m -jar %s %s" % \
            (self.cfg['JAVA_HOME'], 
             os.path.join(self.cfg['DISTRIBUTION_DIR'], "migratorator/migratorator.jar"), 
             " ".join(args))

        self.log.info("About to execute migratorator command: %s" % command)
        self.log.info(app.util.executeCommand(command))
