__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Copy static files to Apache root"

    def createRuntime(self):
        if self.cfg.has_key('HTTPD_DOCUMENT_ROOT'):
            httpdDocumentRoot = self.cfg['HTTPD_DOCUMENT_ROOT']
            if not os.path.exists(httpdDocumentRoot):
                 self.logMesg("error","Missing directory %s" % (httpdDocumentRoot))
                 raise Exception("Missing directory %s" %(httpdDocumentRoot))
            else:
                cmdStr = "unzip -qo %s/css.war -d %s/css" % (self.cfg['DEPLOY_FILES_DIR'], httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cmdStr = "rm -rf %s/css/WEB-INF" % (httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cmdStr = "rm -rf %s/css/META-INF" % (httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cmdStr = "unzip -qo %s/sf-images.war -d %s/sf-images" % (self.cfg['DEPLOY_FILES_DIR'], httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cmdStr = "rm -rf %s/sf-images/WEB-INF" % (httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cmdStr = "rm -rf %s/sf-images/META-INF" % (httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)

                cliSrcImgPath = os.path.join(self.cfg['DISTRIBUTION_DIR'], 'clireports', 'images', 'cn-reports')
                cliDstImgPath = os.path.join(httpdDocumentRoot, "sf-images", "cn-reports")
                
                if os.path.isdir(cliSrcImgPath) and os.path.isdir(cliDstImgPath):
                   cmdStr = "cp -rf %s/* %s"%(cliSrcImgPath, cliDstImgPath)
                   app.util.runSystem(cmdStr, self.log)
                   
                cmdStr = "cp -rf %s %s"%(os.path.join(self.cfg['DISTRIBUTION_DIR'], 'apidoc'), httpdDocumentRoot)
                app.util.runSystem(cmdStr, self.log)
