﻿__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import app.defaults
import os


class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Copy Runtime scripts"

    def createRuntime(self):
        runtimeScriptsDir = os.path.join(self.cfg['RUNTIME_DIR'], 'scripts')
        if not os.path.isdir(runtimeScriptsDir):
            os.makedirs(runtimeScriptsDir)
            
        app.preprocessor.copyScriptsWithTransform(
            self.cfg, 
            os.path.join(app.defaults.DEFAULT_SERVICE_DIR, "ctfcore", "scripts"),
            runtimeScriptsDir)

        if not os.path.isdir(os.path.join(runtimeScriptsDir, "codesearch")):
            os.makedirs(os.path.join(runtimeScriptsDir, "codesearch"))

        app.preprocessor.copyScriptWithTransform(
            self.cfg,
            os.path.join(app.defaults.DEFAULT_SERVICE_DIR,"bdcs", "scripts", "codesearch", "codesightmigration.sh"),
            os.path.join(runtimeScriptsDir, "codesearch", "codesightmigration.sh"))

        app.util.runSystem("chmod -R +x %s" % runtimeScriptsDir, self.log)
