_copyright__ = "Copyright (c) 1999-2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript
import os
import socket
import time

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        self.option = self.cfg.get('CEE_COMPATIBLE', 'false')
        
        if self.option == 'true':
      	        rule =  """
                
RewriteEngine on

# Support URL Compatibility 

#==== Begin Discussions ====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/ds/manageSubscriptions.do.*  {__ROOT_URL__}/sfmain/do/myMonitoringSettings/projects.%1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/ds/manageSubscriptions.do.*  {__ROOT_URL__}/sfmain/do/myMonitoringSettings/projects.%1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/ds/viewAddForum.do.*  {__ROOT_URL__}/discussion/do/createForum/projects.%1/discussion [R=301,L]		
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}	
RewriteRule ^/ds/(.*) {__ROOT_URL__}/urs/projects/%1/ds/$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/CTSearch(.*) {__ROOT_URL__}/urs/projects/%1/servlets/CTSearch$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/WebFeed(.*) {__ROOT_URL__}/urs/projects/%1/servlets/WebFeed$1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/ds/viewAddForum.do.*  {__ROOT_URL__}/discussion/do/createForum/projects.%1/discussion [R=301,L]		
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}	
RewriteRule ^/ds/(.*) {__ROOT_URL__}/urs/projects/%1/ds/$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/CTSearch(.*) {__ROOT_URL__}/urs/projects/%1/servlets/CTSearch$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/WebFeed(.*) {__ROOT_URL__}/urs/projects/%1/servlets/WebFeed$1 [R=301,L]

#==== End Discussions ====
#==== Begin images in Project pages====
RewriteCond %{HTTP_REFERER} ^(.*){__APPSERVER_DOMAIN__}/sf/go/page([0-9]+)
RewriteRule ^/cn-project-pages/images/(.*) {__ROOT_URL__}/urs/page?id=page%2&image=$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__APPSERVER_DOMAIN__}/sf/projects/(.*)/
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__APPSERVER_DOMAIN__}/sf/page/do/editHtml/projects.(.*)/page.*
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__APPSERVER_DOMAIN__}/sf/sfmain/do/viewProject/projects.(.*)/page.*
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]


RewriteCond %{HTTP_REFERER} ^(.*){__CEE_DOMAIN__}/sf/go/page([0-9]+)
RewriteRule ^/cn-project-pages/images/(.*) {__ROOT_URL__}/urs/page?id=page%2&image=$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__CEE_DOMAIN__}/sf/projects/(.*)/
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__CEE_DOMAIN__}/sf/page/do/editHtml/projects.(.*)/page.*
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]
RewriteCond %{HTTP_REFERER} ^(.*){__CEE_DOMAIN__}/sf/sfmain/do/viewProject/projects.(.*)/page.*
RewriteRule /cn-project-pages/images/(.*) {__ROOT_URL__}/page/do/viewImage/projects.%2/page/$1 [R=301,L]
#==== End images in project pages ====

#==== Begin Project pages====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectProcess(.*) {__ROOT_URL__}/projects/%1/? [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /servlets/ProjectProcess(.*) {__ROOT_URL__}/projects/%1/? [R=301,L]
#==== End project pages ====

#==== Begin Docs =====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/ProjectDocument(.*) {__ROOT_URL__}/urs/projects/%1/servlets/ProjectDocument$1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/ProjectDocument(.*) {__ROOT_URL__}/urs/projects/%1/servlets/ProjectDocument$1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectFolder.* {__ROOT_URL__}/docman/do/listDocuments/projects.%1/docman.root [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /servlets/ProjectFolder.* {__ROOT_URL__}/docman/do/listDocuments/projects.%1/docman.root [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule  ^/files/documents/([0-9]+)/([0-9]+)/(.*)$ {__ROOT_URL__}/urs/projects/%1/servlets/ProjectDocument?documentID=$2&projectID=$1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule  ^/files/documents/([0-9]+)/([0-9]+)/(.*)$ {__ROOT_URL__}/urs/projects/%1/servlets/ProjectDocument?documentID=$2 [R=301,L]
#==== End Docs ====
 
#==== Begin Task/Project dashboard =====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule  /(servlets/)?activity/.* {__ROOT_URL__}/taskmgr/do/viewSummary/projects.%1/taskmgr [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule  /(servlets/)?activity/.* {__ROOT_URL__}/taskmgr/do/viewSummary/projects.%1/taskmgr [R=301,L]
		
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule  /servlets/AMSetup(/)?$  {__ROOT_URL__}/taskmgr/do/viewSummary/projects.%1/taskmgr [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule  /servlets/AMSetup(/)?$  {__ROOT_URL__}/taskmgr/do/viewSummary/projects.%1/taskmgr [R=301,L]
#==== End Task/Project dashboard =====

		
#==== Begin Help ====
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule  /(nonav/)?servlets/HelpTOC(/)?$  http://help.collab.net/index.jsp [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule  /(nonav/)?servlets/HelpTOC(/)?$  http://help.collab.net/index.jsp [R=301,L]
		
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /(nonav/)?scdocs/.*  http://help.collab.net/index.jsp [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /(nonav/)?scdocs/.*  http://help.collab.net/index.jsp [R=301,L]
#==== End Help ====

		
#==== Begin Project News ====
		
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectNews.*  {__ROOT_URL__}/sfmain/do/myPage/projects.%1?selectedTab=news [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule /servlets/NewsItemView.* {__ROOT_URL__}/sfmain/do/myPage/projects.%1?selectedTab=news [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /servlets/ProjectNews.*  {__ROOT_URL__}/sfmain/do/myPage/projects.%1?selectedTab=news [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /servlets/NewsItemView.* {__ROOT_URL__}/sfmain/do/myPage/projects.%1?selectedTab=news [R=301,L]
#==== End Project News  ====

		
#==== Begin www URLs ====
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/AdminUtils.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{REQUEST_URI} ^/servlets/ProjectList 
RewriteCond %{QUERY_STRING} ^type=Categories&mode=TopLevel
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule (.*) {__ROOT_URL__}/categorization/do/adminCategories/projects/categorization.root [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectList.*  {__ROOT_URL__}/sfmain/do/myProjects?selectedTab=all [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/OpenCollabNet.*  {__ROOT_URL__}/sfmain/do/ocn [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/DomainHome  {__ROOT_URL__}/sfmain/do/home [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/UserList.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/UserGroupList.* {__ROOT_URL__}/global/do/listGroupsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/RoleList.*  {__ROOT_URL__}/sfmain/do/listRolesAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/BuildInfo.* {__ROOT_URL__}/sfmain/do/buildInfo [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/AuditLogList.* {__ROOT_URL__}/sfmain/do/auditLogList [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/StartPage.* {__ROOT_URL__}/sfmain/do/myPage  [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/Search.* {__ROOT_URL__}/search/do/search  [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/UserAdd.* {__ROOT_URL__}/sfmain/do/createUser [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/UserGroupAdd.* {__ROOT_URL__}/global/do/createGroup [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectAdd.* {__ROOT_URL__}/sfmain/do/createProject [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/SessionList.* {__ROOT_URL__}/sfmain/do/sessionActivity [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/AllUserEmails.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/UserDelete.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/BroadcastMessage.* {__ROOT_URL__}/sfmain/do/broadcastMessage [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/AdHocQuery.* {__ROOT_URL__}/sfmain/do/adhocQuery [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/LogView.* {__ROOT_URL__}/sfmain/do/listLogFile [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectTemplate.* {__ROOT_URL__}/sfmain/do/myProjects?selectedTab=templates [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/RealmList.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/CompulsoryClickThroughReset.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/IndexerServlet.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule /servlets/IndexDump.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule /servlets/ProjectMemberList.* {__ROOT_URL__}/sfmain/do/userMembership/projects.%1 [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/AdminUtils.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{REQUEST_URI} ^/servlets/ProjectList 
RewriteCond %{QUERY_STRING} ^type=Categories&mode=TopLevel
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule (.*) {__ROOT_URL__}/categorization/do/adminCategories/projects/categorization.root [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/ProjectList.*  {__ROOT_URL__}/sfmain/do/myProjects?selectedTab=all [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/OpenCollabNet.*  {__ROOT_URL__}/sfmain/do/ocn [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/DomainHome  {__ROOT_URL__}/sfmain/do/home [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/UserList.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/UserGroupList.* {__ROOT_URL__}/global/do/listGroupsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/RoleList.*  {__ROOT_URL__}/sfmain/do/listRolesAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/BuildInfo.* {__ROOT_URL__}/sfmain/do/buildInfo [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/AuditLogList.* {__ROOT_URL__}/sfmain/do/auditLogList [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/StartPage.* {__ROOT_URL__}/sfmain/do/myPage  [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/Search.* {__ROOT_URL__}/search/do/search  [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/UserAdd.* {__ROOT_URL__}/sfmain/do/createUser [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/UserGroupAdd.* {__ROOT_URL__}/global/do/createGroup [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/ProjectAdd.* {__ROOT_URL__}/sfmain/do/createProject [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/SessionList.* {__ROOT_URL__}/sfmain/do/sessionActivity [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/AllUserEmails.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/UserDelete.* {__ROOT_URL__}/sfmain/do/listUsersAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/BroadcastMessage.* {__ROOT_URL__}/sfmain/do/broadcastMessage [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/AdHocQuery.* {__ROOT_URL__}/sfmain/do/adhocQuery [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/LogView.* {__ROOT_URL__}/sfmain/do/listLogFile [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/ProjectTemplate.* {__ROOT_URL__}/sfmain/do/myProjects?selectedTab=templates [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/RealmList.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/CompulsoryClickThroughReset.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/IndexerServlet.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*){__CEE_DOMAIN__}
RewriteRule /servlets/IndexDump.* {__ROOT_URL__}/sfmain/do/listProjectsAdmin [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule /servlets/ProjectMemberList.* {__ROOT_URL__}/sfmain/do/userMembership/projects.%1 [R=301,L]
#==== End of www URLs ====

#==== Begin IZ ====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/issues/show(.*) {__ROOT_URL__}/urs/projects/%1/issues/show$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/ProjectIssues.* {__ROOT_URL__}/tracker/do/listArtifacts/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/issues/(query|report|buglist).* {__ROOT_URL__}/tracker/do/searchTracker/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/issues/enter_bug.cgi.* {__ROOT_URL__}/tracker/do/createArtifact/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/issues/.* {__ROOT_URL__}/tracker/do/listArtifacts/projects.%1/tracker.issue_tracker [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/issues/show(.*) {__ROOT_URL__}/urs/projects/%1/issues/show$1 [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/ProjectIssues.* {__ROOT_URL__}/tracker/do/listArtifacts/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/issues/(query|report|buglist).* {__ROOT_URL__}/tracker/do/searchTracker/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/issues/enter_bug.cgi.* {__ROOT_URL__}/tracker/do/createArtifact/projects.%1/tracker.issue_tracker [R=301,L]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/issues/.* {__ROOT_URL__}/tracker/do/listArtifacts/projects.%1/tracker.issue_tracker [R=301,L]
#==== End IZ ====
		
#==== Begin SCM ====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/source/browse/(.*) {__ROOT_URL__}/urs/projects/%1/source/fileLocn/$1 [R=301,NE,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/source/browse/(.*) {__ROOT_URL__}/urs/projects/%1/source/fileLocn/$1 [R=301,NE,L]
#==== End SCM ====

#==== Begin Wiki  ====
RewriteCond %{HTTP_HOST} ^(.*){__APPSERVER_DOMAIN__}
RewriteRule ^/wiki(.*) {__ROOT_URL__}/sfmain/do/myPage  [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/wiki {__ROOT_URL__}/wiki/do/viewPage/projects.%1/wiki/HomePage  [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/wiki/(.*) {__ROOT_URL__}/wiki/do/viewPage/projects.%1/wiki/HomePage  [R=301,L]
#==== End Wiki ====

#==== Begin PT ====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/(tracking|Scarab)(/.*)? {__ROOT_URL__}/urs/projects/%1/servlets/tracking$2?%{QUERY_STRING} [R=301,L,NE]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/(tracking|Scarab)(/.*)? {__ROOT_URL__}/urs/projects/%1/servlets/tracking$2?%{QUERY_STRING} [R=301,L,NE]
#==== End PT ====

#==== Begin Project Metrics ====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/Report.* {__ROOT_URL__}/reporting/do/listReports/projects.%1/reporting [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/Report.* {__ROOT_URL__}/reporting/do/listReports/projects.%1/reporting [R=301,L]

#==== End Project Metrics ====

#==== Begin Generic rule====
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__}
RewriteRule ^/servlets/.* {__ROOT_URL__}/sfmain/do/myPage [R=301,L]

RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__}
RewriteRule ^/servlets/.* {__ROOT_URL__}/sfmain/do/myPage [R=301,L]

#==== Begin Remote publishing URL compatibility====
#Process rules only if the sub-domain is not www and not svn repo root url's
RewriteCond %{HTTP_HOST} !^www\. [NC]
RewriteCond %{REQUEST_URI} !^\/svn\/ [NC]
RewriteCond %{HTTP_HOST} ^(.*)\.{__APPSERVER_DOMAIN__} [NC]
RewriteRule (/nonav)?(.*) {__ROOT_URL__}/projects/%1$2 [R=301,L]

RewriteCond %{HTTP_HOST} !^www\. [NC]
RewriteCond %{REQUEST_URI} !^\/svn\/ [NC]
RewriteCond %{HTTP_HOST} ^(.*)\.{__CEE_DOMAIN__} [NC]
RewriteRule (/nonav)?(.*) {__ROOT_URL__}/projects/%1$2 [R=301,L] """
            
                return rule+"\n";
                    
        else:
            return "RewriteEngine on \n"
