__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseConfigScript

class ConfigScript(BaseConfigScript):
    def configSnippet(self):
   
       if self.cfg['ORCHESTRATE_ENABLED'] == 'true':
          OrcHostName = self.cfg['ORC_HOSTNAME']
          OrcPort     = self.cfg['ORC_PORT']
          OrcProtocol = self.cfg['ORC_PROTOCOL']
          OrcProxiedPath = self.cfg['ORC_PROXIED_PATH'].rstrip('/')

          proxyServerConf=''
          proxyPassConf=''
          proxyPassRevConf=''
          SSLProxyEnb=''
          SSLProxyEnbrhl7 =''
          Loadsslmod=''

          if ( OrcProtocol == 'https' ):
             if self.cfg.has_key("ORC_SSL_CA_CERT_FILE"):
                 OrcSSLCACertFile = self.cfg['ORC_SSL_CA_CERT_FILE']
             else:
                 OrcSSLCACertFile = ''
             if self.cfg['SSL'] == 'off' and "redhat-6" in self.cfg["PLATFORM"]:
                  Loadsslmod = """
LoadModule ssl_module modules/mod_ssl.so
"""
             if OrcSSLCACertFile:            
                 SSLProxyEnb = """
SSLProxyEngine on	
SSLProxyVerify require
SSLProxyVerifyDepth 5
SSLProxyCACertificateFile %s 
SSLProxyCheckPeerCN off
""" % (OrcSSLCACertFile)
             else:
                SSLProxyEnb = """
SSLProxyEngine on	
SSLProxyVerify none
SSLProxyCheckPeerCN off
SSLProxyCheckPeerExpire off
"""

             if "redhat-7" in self.cfg["PLATFORM"]:
                SSLProxyEnbrhl7 = """
SSLProxyCheckPeerName off
"""
          proxyPassConf = """
ProxyPass %s %s://%s:%s%s
""" % (OrcProxiedPath, OrcProtocol, OrcHostName, OrcPort, OrcProxiedPath) 

          proxyPassRevConf = """
ProxyPassReverse %s %s://%s:%s%s
""" % (OrcProxiedPath, OrcProtocol, OrcHostName, OrcPort, OrcProxiedPath) 

          proxyServerConf = """
# Orchestrate Integration
%s
%s
%s
ProxyRequests off
<Proxy *>
   Order deny,allow
   Allow from all
</Proxy>
RewriteRule ^%s$ %s/ [R]
AllowEncodedSlashes On
%s
%s    
""" % (Loadsslmod, SSLProxyEnb, SSLProxyEnbrhl7, OrcProxiedPath, OrcProxiedPath, proxyPassConf, proxyPassRevConf)

          return proxyServerConf
       return ''

