__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import service.util
import service.constants
import os
from app.colors import Color

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Adjust Linux resource limits"

    def createRuntime(self):
        confFile = os.path.join('/etc','security','limits.d','teamforge-core.conf')
        if not os.path.isfile(confFile) :
          self.logMesg("warn", Color.yellow("\n  The resource limits (open "
           + "file count, process count)  for %s \n  have been " % self.cfg['APP_USER'] 
           + "adjusted. For this change to take effect, please reboot \n "
           + "the server after finishing the installation" ))
        app.batch.ConfigBatch(self.log) \
          .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'jboss', 'conf-snippets', 'linux_limits')) \
          .evaluateIntoFile(confFile)
