__copyright__ = "Copyright (c) 2015 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os.path

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create collabnet service script for RHEL7/CentOS7"

    def createRuntime(self):
        if "redhat-7" in self.cfg['PLATFORM']:
            collabnetServiceTmplFile = None
            systemdPath = '/etc/systemd/system'
            collabnetServiceFile = os.path.join(systemdPath, 'collabnet.service')
            collabnetServiceTmplFile = os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'legacy-runtime', 'code-templates', 'collabnet.service.tmpl')
         
            tokenProcessor = app.util.getTokenProcessor(self.cfg)
            tokenProcessor.copyWithSubstitution(collabnetServiceTmplFile, collabnetServiceFile)
