__copyright__ = "Copyright (c) 1999-2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import os
import socket
import time

class OptionScript(BaseOptionScript):

    def optionSnippet(self):
        hosts = [hostName.split( "_")[1] for (hostName, applications) in
                self.cfg.items() if hostName.rfind("HOST_") == 0]
        if not hosts:
            hosts = [self.cfg['NODE_HOSTNAME']]
        ipHosts = []
        domainNames = []
        for hostName in hosts:
            if not self.cfg.has_key('IP_' + hostName):
                try:
                    ipName = socket.gethostbyname(hostName)
                    ipHosts.append("IP_%s=%s" % (hostName,
                       ipName))
                except Exception, e:
                    self.log.warning("Cannot find IP address of %s" % hostName)
                    self.log.warning("Error occurred: "  + str(e))
                    time.sleep(5)
            if not self.cfg.has_key('DOMAIN_' + hostName):
                domainNames.append("DOMAIN_%s=%s" % (hostName, hostName))
        return "%s\n%s" %("\n".join(ipHosts), "\n".join(domainNames))
