__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import os
import service.util
import service.constants

class OptionScript(BaseOptionScript):

    def optionSnippet(self):

        appDomain           = service.util.getApplicationHost(service.constants.APPLICATION_APP)
        bdcsHost            = service.util.getApplicationHost(service.constants.APPLICATION_CODESEARCH)
        codeSearchEnabled     = None
        if (bdcsHost == None):
            codeSearchEnabled = "false"
            return "\n" . join(["CODESEARCH_ENABLED=%s\n" % codeSearchEnabled])
        else:
            codeSearchEnabled = "true"

        # Codesearch Tomcat Properties
        bdcsTomcatAccessLogFormat  = "%h %l %u %t %r %s %b %T %D"
        bdcsTomcatServiceCmd       = "/etc/init.d/bds-codesight-tomcat"
        bdcsSolrPort               = "9184"
        bdcsSSL                    = "off"
        bdcsProtocol               = 'http'
        if self.cfg.has_key('BDCS_SSL') and self.cfg['BDCS_SSL'] == 'on':
           bdcsProtocol = 'https'
        else:
           bdcsProtocol = 'http'

        # Codesearch Postgresql Properties
        bdcsPgsqlServiceCmd        = "/etc/init.d/bds-codesight-postgresql"
        bdcsPgsqlHomeDirRoot       = "/opt/collabnet/blackduck/postgres"

        # Codesearch Installer Properties
        bdcsInstallerPath          = "/opt/collabnet/codesearch-installer"
        bdcsInstallPath            = "/opt/collabnet/blackduck"
        bdcsInstallShortCuts       = "$DO_NOT_INSTALL$"
        bdcsVersion                = "2.1"   # Supported Version

        # Codesearch Runtime Properties
        bdcsScanSourceDirRoot      = "/opt/collabnet/blackduck/scan"
        bdcsSolrHomeDirRoot        = "$PROP_BDS_POSTGRES_HOME_DIR$"
        bdcsSdkSearchLimitMax      = "10"
        bdcsLogDir                 = os.path.join(self.cfg['LOG_DIR'], "codesearch")

        # Codesearch Admin credentials 
        bdcsAdminUsername          = "sysadmin"
        bdcsAdminPassword          = "blackduck"
 
        if (service.util.isApplicationEnabled(service.constants.APPLICATION_CODESEARCH, bdcsHost)):
             return "\n".join(["BDCS_LOG_DIR=%s\n" % bdcsLogDir,
                               "BDCS_TEAMFORGE_HOST=%s\n" % appDomain,
                               "BDCS_TOMCAT_ACCESS_LOG_FORMAT=%s\n" % bdcsTomcatAccessLogFormat,
                               "BDCS_TOMCAT_SERVICE_CMD=%s\n" % bdcsTomcatServiceCmd,
                               "BDCS_SOLR_PORT=%s\n" % bdcsSolrPort,
                               "BDCS_TOMCAT_PROTOCOL=%s\n" % bdcsProtocol,
                               "BDCS_SSL=%s\n" % bdcsSSL,
                               "BDCS_PGSQL_SERVICE_CMD=%s\n" % bdcsPgsqlServiceCmd,
                               "BDCS_PGSQL_HOME_DIR_ROOT=%s\n" % bdcsPgsqlHomeDirRoot,
                               "BDCS_INSTALLER_PATH=%s\n" % bdcsInstallerPath,
                               "BDCS_INSTALL_PATH=%s\n" % bdcsInstallPath,
                               "BDCS_VERSION=%s\n" % bdcsVersion,
                               "BDCS_INSTALL_SHORTCUTS=%s\n" % bdcsInstallShortCuts,
                               "BDCS_SCAN_SOURCE_DIR_ROOT=%s\n" % bdcsScanSourceDirRoot,
                               "BDCS_SOLR_HOME_DIR_ROOT=%s\n" % bdcsSolrHomeDirRoot,
                               "BDCS_SDK_SEARCH_LIMIT_MAX=%s\n" % bdcsSdkSearchLimitMax,
			       "BDCS_ADMIN_USERNAME=%s\n" % bdcsAdminUsername,
                               "BDCS_ADMIN_PASSWORD=%s\n" % bdcsAdminPassword,
                               "CODESEARCH_ENABLED=%s\n" % codeSearchEnabled])
