__copyright__ = "Copyright (c) 2013 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import app.landscape

class OptionScript(BaseOptionScript):
    """ configure JAMES_ACCEPTED_RELAYS """

    def optionSnippet(self):  

        gerritHosts = app.landscape.Landscape.getSite().getMachinesByService('gerrit')  
        jamesAcceptedRelays = "127.0.0.1" + "," + self.cfg["APPSERVER_DOMAIN"]

        # Add both the public and physical host names of all gerrit servers as we cannot
        # be sure which name a reverse lookup of Gerrit's IP resolves to.
        if len(gerritHosts) > 0:           
            domainLst = [host.getPublicName() for host in gerritHosts]
            hostLst = [host.getPhysicalName() for host in gerritHosts]

            jamesAcceptedRelays  = jamesAcceptedRelays +","+",".join(set(domainLst+hostLst))

        return "JAMES_ACCEPTED_RELAYS=%s\n" % jamesAcceptedRelays
