__copyright__ = "Copyright (c) 2012 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import os
import service.util
import app.defaults

class OptionScript(BaseOptionScript):

    def optionSnippet(self):

            dPassword = self.cfg['MIRROR_DATABASE_PASSWORD']
            if dPassword == None or len(dPassword) == 0:
                raise Exception("MIRROR_DATABASE_PASSWORD must be specified and must be a non-empty string.")

            dType = self.cfg['DATABASE_TYPE']
            dHost = self.cfg['MIRROR_DATABASE_HOST']
            dName = self.cfg['MIRROR_DATABASE_NAME']
            dSSL  = self.cfg['DATABASE_SSL']
            distDir = self.cfg['DISTRIBUTION_DIR']
            if dType == 'postgresql':
                if self.cfg.has_key('MIRROR_DATABASE_PORT'):
                    dPort = self.cfg['MIRROR_DATABASE_PORT']
                else:
                    dPort = app.defaults.POSTGRES_DEFAULT_PORT;
                dUrl = "jdbc:postgresql://%s:%s/%s" % (dHost,
                                dPort, dName)
                if dSSL == "on":
                   dUrl += '?ssl=true&amp;sslfactory=org.postgresql.ssl.NonValidatingFactory&amp;'

                return "\n".join(["MIRROR_DATABASE_CONNECTION_URL=%s" % dUrl,
			"MIRROR_DATABASE_PORT=%s" % dPort])
            elif dType == 'oracle':
                if self.cfg.has_key('MIRROR_DATABASE_PORT'):
                    orcPort = self.cfg['MIRROR_DATABASE_PORT']
                else:
                    orcPort = app.defaults.ORACLE_DEFAULT_PORT;
                dUrl = "jdbc:oracle:thin:@%s:%s:%s" % (dHost,
                                orcPort, dName)
                return "\n".join(["MIRROR_DATABASE_CONNECTION_URL=%s" % dUrl,
			"MIRROR_DATABASE_PORT=%s" % orcPort])
            else:
                raise Exception("DATABASE_TYPE=%s is unsupported" % dType)
