__copyright__ = "Copyright (c) 2010 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import app.util
import service.util
import app.preprocessor
import os

class OptionScript(BaseOptionScript):

    def optionSnippet(self):
        dType = self.cfg['DATABASE_TYPE']
        if dType == 'postgresql':
            datamartEnabled = service.util.isServiceEnabled(service.constants.SERVICE_REPORTS_PGSQL,
                service.util.getApplicationHost(service.constants.APPLICATION_REPORTS_DATABASE))
        elif dType == 'oracle':
            datamartEnabled = service.util.isServiceEnabled(service.constants.SERVICE_REPORTS_ORACLE,
                service.util.getApplicationHost(service.constants.APPLICATION_REPORTS_DATABASE))
        else:
                raise Exception("DATABASE_TYPE=%s is unsupported" % dType)

        return "\n".join(["REPORTS_ENABLE_LIFECYCLE_METRICS=false",
                          "REPORTS_ENABLE_REPORT_GENERATION=%s" % str(datamartEnabled).lower()])
