__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import sys
import service.util

class OptionScript(BaseOptionScript):

    def optionSnippet(self):

       if not (len(service.util.getApplicationHosts(service.constants.APPLICATION_DATABASE)) > 0 and
          service.util.getApplicationHost(service.constants.APPLICATION_REPORTS_DATABASE) != None):
          # Return empty if REPORTS_DATABASE is not configured, Condition taken from 10-database-tokens-reporting.py.
          return ""

       # Check if REPORTS_DATABASE_USERNAME and REPORTS_DATABASE_READ_ONLY_USER have the same value
       dUser = self.cfg['REPORTS_DATABASE_USERNAME']
       dReadOnlyUser = self.cfg['REPORTS_DATABASE_READ_ONLY_USER']
       if dUser == dReadOnlyUser:
           self.log.error("REPORTS_DATABASE_USERNAME and REPORTS_DATABASE_READ_ONLY_USER cannot have same value")
           sys.exit(1)

       tokenName = "REPORTS_DATABASE_SSL"
       dSSL = "off"
       appdSSL = self.cfg['DATABASE_SSL']

       # If REPORTS_DATABASE_SSL is configured by customer..
       if self.cfg.has_key(tokenName):
          # Check if datamart and database are running as same instance
          if service.util.isSameInstance():
             # Throw error is database is ssl and datamart is non ssl
             if appdSSL == "on" and self.cfg[tokenName] == "off":
                raise Exception("Database and Datamart Db are running as same instance. But DATABASE_SSL=on, REPORTS_DATABASE_SSL=off is not acceptable.\n So set REPORTS_DATABASE_SSL=on and retry.")
             # Throw error is database is nonssl and datamart is ssl
             elif appdSSL == "off" and self.cfg[tokenName] == "on":
                raise Exception("Database and Datamart Db are running as same instance. But DATABASE_SSL=off, REPORTS_DATABASE_SSL=on is not acceptable.\n So set REPORTS_DATABASE_SSL=off or remove REPORTS_DATABASE_SSL token from your site-options and retry.")
             else:
                dSSL = self.cfg[tokenName]
          else:
             dSSL = self.cfg[tokenName]

       return "\n".join(["REPORTS_DATABASE_SSL=%s" % dSSL])

