__copyright__ = "Copyright (c) 1999-2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import os
import socket
import time
import re
import service.util
import service.constants
import app.tokens.generations

class OptionScript(BaseOptionScript):

    def optionSnippet(self):
        applicationName = service.constants.APPLICATION_APP
        appHost = service.util.getApplicationHost(applicationName)
        tknGenObj = app.tokens.generations.TokenGenerations()
        if not appHost:
           self.log.error("Application '%s' should have a host defined" % applicationName)
           raise Exception("Application '%s' should have a host defined" % applicationName)
        appDomain = service.util.getHostDomain(appHost)
        ceeDomain = re.sub('(w{3}\.)', '', appDomain)
        rootUrl = ""
        soapPort = ""
        soapSsl = ""
        sslCheck = self.cfg.get('SSL','off') == 'on'
        if sslCheck:
           rootUrl = "https"
           soapPort = "443"
           soapSsl = "true"
        else:
           rootUrl = "http"
           soapPort = "80"
           soapSsl = "false"
        returnStr = """
ROOT_URL=%s://%s/sf

# Root (protocol, host & port) URL of SOAP server serving SF API
API_SOAP=%s://%s
API_SOAP_PORT=%s
EXTERNAL_INTEGRATION_PORT=%s
SOAP_USE_SSL=%s
INTEGRATION_LISTENER_SSL=%s

# Email alias for someone responsible for the site. Used in
# sending email from the system and in error messages.
SYSTEM_EMAIL=root@%s
SYSTEM_EMAIL_NAME=TeamForge Administrator

# The admin user default email
ADMIN_EMAIL=root@%s
APPSERVER_DOMAIN=%s
CEE_DOMAIN=%s
""" % (rootUrl,appDomain, rootUrl, appDomain, soapPort, soapPort, soapSsl, soapSsl, appDomain, appDomain, appDomain, ceeDomain)
        return returnStr
