__copyright__ = "Copyright (c) 1999-2009 CollabNet, Inc. All rights reserved."

#
# Adds server names of the form <project-name>.<host-name> to allow cee style discussion email addresses
# of the form <list-name>@<project-name>.<host-name>.
# The file "$DATA_DIR/etc/cee-project-names" will be present only in the sites upgraded to CTF6.0 from CEE
# and it will be created during migration.
# The file shall have one project name per line and shall have only projects where there was a discussion post
# within the previous 6 months of the date of upgrade.
#
from app.scripts import BaseConfigScript
import app.util
import app.preprocessor
import os

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        ceeMailHostNames = ""
        if self.cfg['IS_SCM_SERVER'] == "false":
            if (self.cfg['CEE_COMPATIBLE']):
                stringBegin = '<servername>'
                stringEnd = '.{__CEE_DOMAIN__}</servername>'
                if self.cfg['CEE_DOMAIN'] != self.cfg['JAMES_MTA_HOST']:
                    ceeMailHostNames = "\t\t<servername>{__CEE_DOMAIN__}</servername>\n"
                fileWithCEEProjectNames = os.path.join(self.cfg['DATA_DIR'], 'etc', 'cee-project-names')
                if os.path.exists(fileWithCEEProjectNames):
                    for line in open(fileWithCEEProjectNames):
                        line = line.rstrip()
                        if line:
                            ceeMailHostNames += "\t\t%s%s%s\n" % \
                                            (stringBegin, line, stringEnd)


        return ceeMailHostNames

