__copyright__ = "Copyright (c) 2015 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import service.util
import os.path

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create PostgreSQL service scripts for RHEL7/CentOS7"

    def createRuntime(self):
        if "redhat-7" in self.cfg['PLATFORM']:
            version = self.cfg["PGSQL_VERSION"]
            reportsServiceTmplFile = None
            systemdPath = '/etc/systemd/system'
            reportsServiceFile = os.path.join(systemdPath, 'reporting-postgresql-%s.service' % version)
            reportsServiceTmplFile = os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'postgres-datamart', 'code-templates', 'reporting-postgresql-%s.service.tmpl' % version)
         
            tokenProcessor = app.util.getTokenProcessor(self.cfg)
            tokenProcessor.copyWithSubstitution(reportsServiceTmplFile, reportsServiceFile) 

