__copyright__ = "Copyright (c) 2015 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import service.util
import os.path

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create PostgreSQL service scripts for RHEL7/CentOS7"

    def createRuntime(self):
        if "redhat-7" in self.cfg['PLATFORM']:
            version = self.cfg["PGSQL_VERSION"]
            distributionDir = self.cfg['DISTRIBUTION_DIR']
            ctfServiceTmplFile = None
            systemdPath = '/etc/systemd/system'
            ctfServiceFile = os.path.join(systemdPath, 'ctf-postgresql-%s.service' % version)
            ctfServiceTmplFile = os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'postgres', 'code-templates', 'ctf-postgresql-%s.service.tmpl' % version)
         
            tokenProcessor = app.util.getTokenProcessor(self.cfg)
            tokenProcessor.copyWithSubstitution(ctfServiceTmplFile, ctfServiceFile)

