__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Check and Initialise TeamForge Database"

    def createRuntime(self):
        pgDataDir = self.cfg['PGSQL_DATA_DIR']
        pgHomeDir = self.cfg['PGSQL_HOME_DIR']
        if os.path.islink(pgHomeDir):
            pgHomeDir= os.readlink(pgHomeDir)
        pgPath = os.path.join(pgDataDir, "base")
        pgLogFile = os.path.join(self.cfg['PGSQL_LOG_DIR'], 'initdb.log')
        if not os.path.exists(pgPath):
            app.util.runSystem("mkdir -p %s" % pgHomeDir, self.log)
            app.util.runSystem("chown -R postgres:postgres %s" % pgHomeDir,
                    self.log)
            self.logMesg("debug", "Initializing the postgresql database.. please wait")
            logStr = ""
            if os.path.exists(pgLogFile):
                logStr = " > %s 2>&1 " % pgLogFile
            if "redhat-7" in self.cfg["PLATFORM"]:
                initCommand = "%s/postgresql" % self.cfg['RUNTIME_SCRIPTS']
            else:
                initCommand = self.cfg['PGSQL_SERVICE_CMD']
            app.util.runCommand("%s initdb" % initCommand, self.log)
