__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Setup PostgreSQL Control script"

    def createRuntime(self):
        if "redhat-7" in self.cfg["PLATFORM"]:
            pgVersion = self.cfg["PGSQL_VERSION"]            
            tfSystemd = os.path.join(self.cfg["RUNTIME_SCRIPTS"], 'tfsystemd')
            
            # Stop and disable default postgresql service from starting on boot
            app.util.runSystem("%s postgresql-%s stop &> /dev/null" %(tfSystemd, pgVersion), self.log)
            app.util.runSystem("%s postgresql-%s disable &> /dev/null" %(tfSystemd, pgVersion), self.log)

            # Disable our custom postgresql script not to start automatically at boot
            app.util.runSystem("%s ctf-postgresql-%s disable &> /dev/null" %(tfSystemd, pgVersion), self.log)
        else:
            initScript = self.cfg['PGSQL_SERVICE_CMD'].split(" ")[0].split('/')[-1] 
            app.util.runSystem("/sbin/chkconfig  --level 345 %s off &> /dev/null" % initScript, self.log)
