import os
import app.servicecontrol

class ServiceController(app.servicecontrol.ServiceController):
    def getPidFile(self):
        return "/var/run/monit.pid"

    def __runInit(self, verb):
        config = app.util.getRuntimeConfiguration()

        logFile = os.path.join(config['LOG_DIR'], 'monit', 'service.log')
        initScript = config["MONIT_SERVICE_CMD"]

        return os.system("%s %s < /dev/null >> %s 2>&1 &" % (initScript, verb, logFile)) == 0
        
    def startDaemonAsync(self):
        return self.__runInit("start")
        
    def stopDaemonAsync(self):
        return self.__runInit("stop")
